# TI-99/sim common build rules

CC       := g++
CFLAGS   := -g -O2 -fno-exceptions -fno-rtti
WARNINGS := -Wall -Wno-format -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Winline
INCLUDES := -I../../include

ifdef ARCH
CFLAGS   += -march=$(ARCH)
endif

ifdef BIG_ENDIAN
CFLAGS   += -DBIG_ENDIAN
endif

ifdef DEBUG
CFLAGS   += -DDEBUG
endif

ifdef WIN32
CFLAGS   += -D__WIN32__
endif

.cpp.o:
	$(CC) -c $(CFLAGS) $(WARNINGS) $(INCLUDES) -o $@ $<

.SUFFIXES: .cpp .o
